/*
  Filename: pashut.c  
  Synopsys: Shutdown dialog for closing pawm
    
 	                 Copyright (C) 2001-2006  
	         David Gmez Espinosa <david@pleyades.net>

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  version 2 as published by the Free Software Foundation

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "pawindow.h"
#include "pabar.h"
#include "pafont.h"
#include "pashut.h"


static void shut_all(void *);
static void back_to_pawm(void *);

static Window condomwindow;       /* To 'protect' shutdown window ;) */
static Window theShutwindow;
static PALabel labelyes,labelno;  /* Dialog labels */
static PAFont shutfont;
//static Picture curtain;

void try_to_shut(void *noparam)
{ 
	assert(!noparam);

	/* First window is a layer to avoid clicking while the shut dialog is
	 * on the screen, second window is the dialog itself */
	condomwindow=XCreateWindow(xclass.display, ROOT, 0, 0, DWIDTH, DHEIGHT, 0, 0,
							   InputOnly, DEFAULTVISUAL, 0,NULL);
	theShutwindow=XCreateSimpleWindow(xclass.display, ROOT, SHUTX, SHUTY, SHUTWIDTH, SHUTHEIGHT,
						  			  1, x_color("frame_dark"), x_color("frame_base_color"));

	//XRenderColor color={0,0,0,34000};
	//XRenderPictureAttributes pa;
	//pa.subwindow_mode=IncludeInferiors;
	//curtain=XRenderCreatePicture(xclass.display, ROOT, RENDERFORMAT, CPSubwindowMode, &pa);
	//XGrabKeyboard(xclass.display, ROOT, True, GrabModeAsync, GrabModeAsync, CurrentTime);

	//XRenderFillRectangle (xclass.display, PictOpXor, curtain, &color, 0, 0, DWIDTH, DHEIGHT);
	//XRenderFillRectangle (xclass.display, PictOpOverReverse, curtain, &color, 0, 0, DWIDTH, DHEIGHT);

	/* Create labels of the shutdown dialog */
	labelyes=palabel_create(SHUTLABELW, shut_all, NULL);
	palabel_settext(labelyes, "Yes", strlen("Yes"));
	palabel_reparent(labelyes, theShutwindow, SHUTPOSX, SHUTLABELY);
	palabel_map(labelyes, SHUTLABELW);
		
	labelno=palabel_create(SHUTLABELW, back_to_pawm, NULL);
	palabel_settext(labelno, "No", strlen("No"));
	palabel_reparent(labelno, theShutwindow, SHUTPOSX*2+SHUTLABELW, SHUTLABELY);
	palabel_map(labelno, SHUTLABELW);

	/* Draw all */
	XMapRaised(xclass.display,condomwindow);	
	XMapRaised(xclass.display, theShutwindow);

	shutfont=pafont_create(xclass.display, "pawindow");    
	pafont_setcolor(shutfont, "black");
	pafont_draw(shutfont, theShutwindow, (SHUTWIDTH-pafont_width(shutfont,SHUTTEXT,strlen(SHUTTEXT)))/2, 8,
				SHUTTEXT, strlen(SHUTTEXT));
}


static void shut_all(void *noparam)
{
	assert(!noparam);
    
    kill(getpid(), SIGTERM);
}


static void back_to_pawm(void *noparam)
{
	//XRenderColor color={0,0,0,34000};

	assert(!noparam);

	/* Back to life again ;) */
	palabel_destroy(labelyes);
	palabel_destroy(labelno);
	pafont_destroy(shutfont);
	XDestroyWindow(xclass.display, theShutwindow);
	XDestroyWindow(xclass.display, condomwindow);
	XClearWindow(xclass.display, ROOT);
	//  XRenderFillRectangle (xclass.display, PictOpXor, curtain, &color, 0, 0, DWIDTH, DHEIGHT);
	//	XUngrabKeyboard(xclass.display, CurrentTime);
}
					

